# Phantom script by NowakPL <nowak@xpam.de>

local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')

function OnPopulate()
	ScenarioUtils.InitializeArmies()
end

function PhantomResourceThread(players, phantom_army)
	WaitSeconds(8 * 60)

	for tmp, army in players do
		if army == GetFocusArmy() then
			if army == phantom_army then
				PrintText('You are the Phantom!', 20, nil, 15, 'center')
			else
				PrintText('Identify and kill the Phantom!', 20, nil, 15, 'center')
			end
		end
	end

	local phantom_army_brain = GetArmyBrain(phantom_army)
	phantom_army_brain:GiveStorage('MASS', 2000)
	phantom_army_brain:GiveStorage('ENERGY', 10000)
	while true do
		WaitSeconds(0.1)
		local mass = 0
		local energy = 0
		local bonus = 0
		for index, army in ArmyBrains do
			if ArmyIsCivilian(index) == false and index != phantom_army then
				if ArmyIsOutOfGame(index) == false then
					mass = mass + army:GetEconomyIncome('MASS')
					energy = energy + army:GetEconomyIncome('ENERGY')
				else
					bonus = bonus + 1
				end
			end
		end
		phantom_army_brain:GiveResource('MASS', mass * (0.3 + bonus * 0.1))
		phantom_army_brain:GiveResource('ENERGY', energy * (0.3 + bonus * 0.1))
	end
end

function PhantomMainThread()
	local players = {}
	local players_n = 0
	for index, army in ArmyBrains do
		if ArmyIsCivilian(index) == false and ArmyIsOutOfGame(index) == false then
			players[players_n + 1] = index
			players_n = players_n + 1
		end
	end
	
	for tmp, army in players do
		local brain = GetArmyBrain(army)
		brain:SetResourceSharing(false)
		SetAlliedVictory(army, false)
		for tmp2, army2 in players do
			SetAlliance(army, army2, 'Ally')
		end
	end
	local phantom_army = players[Random(players_n)]
	local phantom_resource_thread = ForkThread(PhantomResourceThread, players, phantom_army)
	
	local abort_loop = false
	local old_players_alive = -1
	while abort_loop == false do
		WaitSeconds(0.1)
		local players_alive = 0
		local phantom_alive = 0
		for tmp, army in players do
			local brain = GetArmyBrain(army)
			SetAlliedVictory(army, false)
			if not brain:IsDefeated() then
				if army == phantom_army then
					phantom_alive = 1
				else
					players_alive = players_alive + 1
				end
			end
		end
		if old_players_alive >= 0 and old_players_alive != players_alive then
			PrintText('Innocent player has been killed! The Phantom receives resource boost!', 20, nil, 10, 'center')
		end
		if phantom_alive >= 1 and players_alive < 1 then
			PrintText('The Phantom has won!', 20, nil, 10, 'center')
			WaitSeconds(5)
			abort_loop = true
		end
		if phantom_alive < 1 and players_alive >= 1 then
			PrintText('The Phantom has been killed!', 20, nil, 10, 'center')
			WaitSeconds(5)
			abort_loop = true
		end
		if phantom_alive < 1 and players_alive < 1 then
			PrintText('The game ends in a draw!', 20, nil, 10, 'center')
			WaitSeconds(5)
			abort_loop = true
		end
		old_players_alive = players_alive
	end
	for tmp, army in players do
		local brain = GetArmyBrain(army)
		if not brain:IsDefeated() then
			brain:OnVictory()
		end
	end
end

function OnStart(self)
	for index, brain in ArmyBrains do
		brain.CalculateScore = function(this_brain)
			return this_brain:GetArmyStat("UnitCap_Current", 0.0).Value
		end
	end

	local phantom_main_thread = ForkThread(PhantomMainThread)
end
